Subject: Re: [OAUTH-WG] Proof of Possession Tokens: Next Steps

From: Hannes Tschofenig <[email-masked]>
Date: Thu, 4 Feb 2016 20:14:27 +0100

Hi Justin,

you have not been removed from the author list of the HTTP signing
draft. Unfortunate wording in my mail below may have given you that
impression but I would like to bring some additional people on board who
expressed interest.

As you know, it is also great if we get new people to volunteer to do
work when we get stuck.

Since there needs to be "space" on the author list I would at least
remove myself from the author list of the HTTP signing document.

Ciao
Hannes

PS: I saw your post regarding the PoP implementation. Thanks for doing
that work. It is highly appreciated!

On 01/19/2016 05:34 PM, Justin Richer wrote:
> Well that’s interesting: I was unaware I was being removed as the author
> of the HTTP signing draft. This is especially surprising after the
> presentation I gave at Yokohama about this topic. The draft hasn’t been
> updated because there’s not really been any discussion on it here in the
> group to drive an update, and I’m not one to artificially publish a new
> draft with the same content and a new date just to avoid the “expired”
> tag in the repository. 
> 
> To see the direction I proposed that we go in at Yokohama, check my
> slides here:
> 
> https://www.ietf.org/proceedings/94/slides/slides-94-oauth-3.pdf
> 
> Again, I got no real feedback on this and there was no discussion on the
> list. Even so, I’m implementing this in a Node.js application anyway
> that I plan to post back to the group here when it’s done. 
> 
>  — Justin
> 
>> On Jan 19, 2016, at 6:45 AM, Hannes Tschofenig
>> <[email-masked] <mailto:[email-masked]>> wrote:
>>
>> Hi all,
>>
>> I wanted to drop a high level message about possible next steps for the
>> PoP work.
>>
>> As you have seen from my status update, see
>> http://www.ietf.org/mail-archive/web/oauth/current/msg15327.html, the
>> PoP architecture document was already in IESG processing but I have had
>> asked Kathleen to delay the publication given that we ran into scoping
>> issues, as discussed on the list. See
>> http://www.ietf.org/mail-archive/web/oauth/current/msg15177.html
>>
>> The change of scope related to desire to not just binding a key to the
>> access token but also to other parts of the OAuth system to avoid cases
>> where an attacker can just obtain attack other parts of the system
>> instead (for example, by obtaining an bearer-based refresh token to then
>> obtain a new PoP access token).
>>
>> The recently discovered security problems tell us that we need to
>> simplify our solutions a bit as well to ensure that we get the security
>> analysed properly. More options means more time to analyse all the
>> different options.
>>
>> What does this mean to simplify when I talk about expanding the scope in
>> the earlier paragraph?
>>
>> I am suggesting to
>>
>> * to consider focusing on a public key-based only solution for the
>> web/smart phone app space. (The ACE working group will have to develop a
>> symmetric key-based version on their own, if desired.)
>>
>> * to extend the support of PoP token functionality throughout the entire
>> solution. This means that we have to include support for a asymmetric
>> version of PKCE into account (which had been discussed in the group
>> already earlier already).
>>
>> * to define at least a TLS-based security security solution for the
>> communication between the client and the resource server.
>>
>> * to rethink the work on the application layer security solution. The
>> HTTP signing draft, which defines the application layer security
>> solution for use between the client and the resource server, has expired
>> and we will have to find new authors. I believe we got stuck a bit.
>> Luckily new persons came along and volunteered to help, namely Fredrik
>> Ljunggren and Jakob Schlyter. Nevertheless, the group will have to judge
>> whether a newly developed application layer security solution is
>> promising. My impression is that it is a very difficult to come up with
>> a solution that satisfies the security requirements and, at the same
>> time, also takes the deployment status of proxies and other middleware
>> into account.
>>
>> * to make a decision about other extensions. Nat and Kepeng submitted
>> the Sender Constrained JWT for OAuth2 2.0 document, see
>> https://tools.ietf.org/html/draft-sakimura-oauth-rjwtprof-06
>> We asked the working group for feedback during IETF #93 and we couldn't
>> get enough feedback at that time. Please give us feedback whether you
>> are interested in exploring that solution direction as part of this
>> process. Today, we don't have enough indication of interest for working
>> on that solution direction.
>>
>> Before making any changes to the PoP document set we would like to hear
>> your thoughts.
>>
>> Ciao
>> Hannes
>>
>> _______________________________________________
>> OAuth mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/oauth
>

---

From: Hannes Tschofenig <[email-masked]>
Date: Thu, 4 Feb 2016 20:17:14 +0100

Hi Kepeng,

thanks for your input.

> Yes, I am interested in this solution direction.
> 
> Sender Constrained JWT is already indicated in PoP architecture document
> as one of the solutions.

That is correct.

> 
> If we don’t specify it in detail, the solution set is incomplete.

That's unfortunately wrong. The Sender Constrained JWT is one solution
that essentially provides the same functionality to the PoP token.

> 
> And there will be interoperability issues when people implement it in
> different ways.
That's correct. However, the group decided to go on a different route,
namely the PoP token route and if we can reduce the number of options
that people use to implement the same functionality then that's actually
better in the long run.

Ciao
Hannes

> 
> Kind Regards
> Kepeng
> 
> 在 19/1/16 7:45 pm， "Hannes Tschofenig" <[email-masked]> 写入:
> 
>> Hi all,
>>

---

From: Justin Richer <[email-masked]>
Date: Thu, 4 Feb 2016 20:06:02 -0500

Hannes, thanks for your clarification.

I believe what we need is more working group involvement and feedback and not more authors on the document. As I’ve explained off-list and on several times, the document didn’t move forward in the last year because there hadn’t been any discussion or reason to move it forward. Now I have a reason to move it forward on my own, so I’ve contributed the implementation and updated text.

I’m of course happy to have additional authors if they’re interested in contributing to the draft text itself and helping to edit it. I’m surprised that there are people willing to edit the document when there haven’t been any public discussions of it to date, so I would suggest that as a WG we start there.

 — Justin

> On Feb 4, 2016, at 2:14 PM, Hannes Tschofenig <[email-masked]> wrote:
> 
> Hi Justin,
>